-- HitList! not that this game has many item interactions lol
-- by GenericHeroGuy
-- icons by Spee (thank you!)

local cv_enabled = CV_RegisterVar({
	name = "hitlist",
	defaultvalue = "On",
	possiblevalue = CV_OnOff,
--	description = "Show players getting hit." -- the punctuation wars continue
})

rawset(_G, "cv_hl", cv_enabled)

local cv_colorize = CV_RegisterVar({
	name = "hl_colorize",
	defaultvalue = "On",
	possiblevalue = CV_OnOff,
})

local hitlist = {}
local timetolive = TICRATE*4
local check = {}

local function AddHit(hit)
	if not cv_enabled.value then return end

	if hit.source then
		for _, hit2 in ipairs(hitlist) do
			if hit.source == hit2.source and hit.icon == hit2.icon then
				-- check for combos
				-- "WHY ARE YOU USING THE ICON!?"
				-- i mean, it effectively doubles as a "hit type"
				-- ...you ARE giving unique icons to everything, right? :)
				if hit2.targets[hit.target] then
					hit2.targets[hit.target] = $ + 1
					hit2.timestamp = leveltime
					hit2.timetodie = leveltime + timetolive
					return
				-- check for multihits
				else
					-- deaths must occur on the same tic to count
					if not (hit.death and hit2.timestamp ~= leveltime) then
						hit2.targets[hit.target] = 1
						table.insert(hit2.targetorder, hit.target)
						hit2.timestamp = leveltime
						hit2.timetodie = leveltime + timetolive
						return
					end
				end
			end
		end
	end

	-- no combo
	hit.targets = { [hit.target] = 1 }
	hit.targetorder = { [0] = hit.target }
	hit.timestamp = leveltime
	hit.timetodie = leveltime + timetolive
	table.insert(hitlist, hit)
end

rawset(_G, "HL_AddHit", AddHit)

-- I'M TIRED OF PRETENDING THAT THE 8-CHARACTER LIMIT IS STILL A THING AAAAAAAA
local simple = {
	[MT_SSMINE_SHIELD] = "HL_SSMINE",
	[MT_ORBINAUT] = "HL_ORBI",
	[MT_ORBINAUT_SHIELD] = "HL_ORBI",
	[MT_JAWZ] = "HL_JAWZ",
	[MT_JAWZ_DUD] = "HL_JAWZ",
	[MT_JAWZ_SHIELD] = "HL_JAWZ",
	[MT_BANANA] = "HL_BANAN",
	[MT_BANANA_SHIELD] = "HL_BANAN",
	[MT_BALLHOG] = "HL_BHOG",
	[MT_SPB] = "HL_SPB",
}

addHook("PlayerSpin", function(player, inflictor, source)
	if not (inflictor and source and source.player) then return end

	local icon
	local flash

	if inflictor.type == MT_PLAYER then
		local iplayer = inflictor.player

		if iplayer.kartstuff[k_invincibilitytimer] > 0 then
			icon = "HL_INVNC"
		elseif iplayer.kartstuff[k_pogospring] then
			icon = "HL_STOMP"
		elseif iplayer.kartstuff[k_sneakertimer] > 0 then
			icon = "HL_SNEAKER"
		elseif iplayer.kartstuff[k_curshield] == 1 then
			icon = "HL_LSHLD"
		else
			print("uhhh what kinda player attack is this")
			return
		end
	elseif inflictor.type == MT_SPBEXPLOSION then
		icon = (inflictor.extravalue1 == 0) and "HL_EGG" or "HL_SPB"
		if (inflictor.extravalue1 == 0) then
			flash = true
		end
	else
		icon = simple[inflictor.type]
	end

	if not icon then return end

	if inflictor.type == MT_BANANA and inflictor.health > 1 then -- banan snipe
		flash = true
	end

	local hit = {
		target = player,
		inflictor = inflictor,
		source = source.player,
		icon = icon,
		flash = flash,
	}

	AddHit(hit)
end)

addHook("PlayerExplode", function(player, inflictor, source)
	if not (inflictor and source and source.player) then return end

	local icon

	if inflictor.type == MT_SPBEXPLOSION then
		icon = (inflictor.extravalue1 == 0) and "HL_EGG" or "HL_SPB"
	else
		icon = simple[inflictor.type]
	end

	if not icon then return end

	local hit = {
		target = player,
		inflictor = inflictor,
		source = source.player,
		icon = icon,
		flash = true,
	}

	AddHit(hit)
end)

addHook("PlayerSquish", function(player, inflictor, source)
	if not (inflictor and source and source.player) then return end

	local icon

	if inflictor.type == MT_PLAYER then
		icon = "HL_STOMP"
	end

	if not icon then return end

	local hit = {
		target = player,
		inflictor = inflictor,
		source = source.player,
		icon = icon,
	}

	AddHit(hit)
end)

addHook("MobjDamage", function(target, inflictor, source)
	if not (target.valid and target.player) then return end -- Uuh is this possible?

	if inflictor and inflictor.type == MT_SINK then
		AddHit({
			death = true,
			target = target.player,
			inflictor = inflictor,
			source = source and source.player,
			icon = "HL_SINK",
			flash = true,
		})
	end
end, MT_PLAYER)

HL_OnHyudoroSteal(function(victim, stealer)
	AddHit({
		target = victim,
		inflictor = stealer.mo,
		source = stealer,
		icon = "HL_HYU",
		rightpad = 9,

		hyuitem = K_GetItemPatch(stealer.kartstuff[k_itemtype], true),
		hyuamount = stealer.kartstuff[k_itemamount],
		extrafunc = function(v, hit, ofs, hx, hy, vflags)
			local icon = v.cachePatch(hit.hyuitem)
			local scale = FixedDiv(8, max(8, icon.height/2))
			hx = $ + ofs.icon
			v.drawScaled((hx+3)*FRACUNIT, (hy-3)*FRACUNIT - FRACUNIT/2, scale, icon, vflags, cmap)
			if hit.hyuamount > 1 then
				-- Too lazy to create separate function, and there are only 255 items max soo
				local nums = { hit.hyuamount/100, (hit.hyuamount % 100) / 10, hit.hyuamount % 10 }
				local last_nonzero = false
				
				for _, num in ipairs(nums) do
					if num == 0 and not last_nonzero then continue end
					
					last_nonzero = true
					
					local patch = v.cachePatch(string.format("PINGN%01d", num))
					v.drawScaled((hx+12)*FRACUNIT, (hy+5)*FRACUNIT, FRACUNIT/2, patch, vflags)
					hx = hx + 2
				end
			end
		end
	})
end)

addHook("MapChange", do hitlist = {} end)

local HEIGHT = 9
local ICONHEIGHT = 8
local ICONOFFSET = FRACUNIT/2
local V_100TRANS = V_50TRANS*2
local FONTHEIGHTS = { thin = 9, small = 4 }

-- Should i expose others? I expose those because i need it in hitfeedcompat
rawset(_G, "HL_ICONHEIGHT", ICONHEIGHT)
rawset(_G, "HL_ICONOFFSET", ICONOFFSET)

-- somebody disconnected? no problem, just replace them :^)
local function CheckValid(hit)
	if hit.source and not hit.source.valid then
		hit.source = { name = "???", skincolor = 1, valid = true }
	end
	for target, combo in pairs(hit.targets) do
		if not target.valid then
			local dummy = { name = "???", skincolor = 1, valid = true }
			hit.targets[dummy] = combo
			hit.targets[target] = nil
			for i = 0, #hit.targetorder do
				if hit.targetorder[i] == target then hit.targetorder[i] = dummy end
			end
		end
	end
end

local function GetFont(v, name, vflags)
	local font = "thin"
	local width = v.stringWidth(name, vflags, font)
	if width >= 60 then -- too long
		font = "small"
		width = v.stringWidth(name, vflags, font)
	end
	return font, width
end

local function GetOffsets(v, hit, vflags)
	local ox = 0
	local ofs = {}

	ofs.left = ox
	if hit.source and not hit.targets[hit.source] then
		local font, width = GetFont(v, hit.source.name, vflags)
		ofs.sourcefont = font
		ox = $ + width
	end
	ox = $ + (hit.leftpad or 1)

	ofs.icon = ox
	if hit.icon then
		local icon = v.cachePatch(hit.icon)
		local scale = FixedDiv(ICONHEIGHT, max(ICONHEIGHT, icon.height))
		ofs.icon = ox
		ox = $ + (icon.width*scale)>>FRACBITS
	end
	ox = $ + (hit.rightpad or 1)

	ofs.right = ox
	local add = 0
	ofs.targetfont = {}
	for target, combo in pairs(hit.targets) do
		local font, width = GetFont(v, target.name, vflags)
		ofs.targetfont[target] = font
		add = max($, width + (combo > 1 and v.stringWidth("x"..combo, vflags, "thin") + 1 or 0))
	end
	ox = $ + add

	ofs.edge = ox
	return ofs
end

local function GetColorMap(v, icon)
	local cmap = v.getColormap(TC_DEFAULT, SKINCOLOR_WHITE)

	if cv_colorize.value == 0 then return cmap end

	if icon == "HL_JAWZ" then
		cmap = v.getColormap(TC_DEFAULT, SKINCOLOR_JAWZ)
	elseif icon == "HL_BANAN" then
		cmap = v.getColormap(TC_DEFAULT, SKINCOLOR_YELLOW)
	elseif icon == "HL_BHOG" then
		cmap = v.getColormap(TC_DEFAULT, SKINCOLOR_LILAC)
	elseif icon == "HL_EGG" then
		cmap = v.getColormap(TC_DEFAULT, SKINCOLOR_ROSE)
	elseif icon == "HL_LSHLD" then
		cmap = v.getColormap(TC_DEFAULT, SKINCOLOR_CYAN)
	elseif icon == "HL_SNEAKER" then
		cmap = v.getColormap(TC_DEFAULT, SKINCOLOR_RASPBERRY)
	elseif icon == "HL_INVNC" then
		cmap = v.getColormap(TC_DEFAULT, leveltime % MAXSKINCOLORS)
	end

	return cmap
end

local function IsLocalPlayer(p)
	for i = 0, 3 do
		if displayplayers[i] and displayplayers[i] == p then
			return true
		end
	end
	
	return false
end

local function HasLocalPlayers(t)
	for i = 0, 3 do
		if displayplayers[i] and t[displayplayers[i]] then
			return true
		end
	end
	
	return false
end

-- Taken from libsg, only ones we need
local translations = {
	[SKINCOLOR_WHITE] = {120, 120, 120, 120, 0, 2, 5, 8, 9, 11, 14, 17, 20, 22, 25, 28},
	[SKINCOLOR_BLACK] = {4, 7, 11, 15, 20, 22, 24, 27, 28, 28, 28, 29, 29, 30, 30, 31},
}

hud.add(function(v, p, c)
	if c.pnum > 1 then return end -- Only draw that once

	for i = #hitlist, 1, -1 do
		if leveltime >= hitlist[i].timetodie then
			-- "Time to die, I guess!"
			table.remove(hitlist, i)
		end
	end

	local hy = 4
	local tallest = 64
	local snap = V_SNAPTOTOP|V_SNAPTOLEFT
	
	if splitscreen then
		snap = 0
		
		local totalheight = 0
		local maxwidth = 0
		
		for _, hit in ipairs(hitlist) do
			local multiheight = -HEIGHT
			for _ in pairs(hit.targets) do multiheight = $ + HEIGHT end
			
			totalheight = $ + HEIGHT + multiheight + 3
		end
		
		hy = 100 - totalheight / 2
	end
	
	local maxhy = hy + tallest

	for i, hit in ipairs(hitlist) do
		CheckValid(hit)

		local trans = (V_10TRANS*max(v.localTransFlag()>>V_ALPHASHIFT, leveltime - hit.timetodie + 10))

		local vflags = snap|trans
		local hx = 56

		local multiheight = -HEIGHT
		for _ in pairs(hit.targets) do multiheight = $ + HEIGHT end

		local light = IsLocalPlayer(hit.source) or HasLocalPlayers(hit.targets)

		local offsets = GetOffsets(v, hit, vflags)
		offsets.multiheight = multiheight
		local cmap = translations[light and SKINCOLOR_WHITE or SKINCOLOR_BLACK]
		local bg = cmap[light and 4 or 8]
		local corner = cmap[light and 8 or 12]
		local top = cmap[light and 4 or 8]
		local side = cmap[light and 4 or 8]

		-- background/corner/side widths/heights
		local bw = offsets.edge
		local bh = HEIGHT + multiheight
		local cw = offsets.edge + 1
		local ch = HEIGHT + multiheight
		local sw = offsets.edge
		local sh = HEIGHT + multiheight
		
		-- Centered on splitscreen
		if splitscreen then
			hx = 160 - offsets.edge/2
		end

		hy = $ + 3

		-- background
		v.drawFill(hx, hy, bw, bh, bg|vflags)

		-- top, bottom, left, right
		v.drawFill(hx, hy - 1, sw, 1, top|vflags)
		v.drawFill(hx, hy + sh, sw, 1, top|vflags)

		v.drawFill(hx - 1, hy, 1, sh, side|vflags)
		v.drawFill(hx + sw, hy, 1, sh, side|vflags)

		-- top left, top right, bottom left, bottom right
		v.drawFill(hx - 1, hy - 1, 1, 1, corner|vflags)
		v.drawFill(hx + cw-1, hy - 1, 1, 1, corner|vflags)
		v.drawFill(hx - 1, hy + ch, 1, 1, corner|vflags)
		v.drawFill(hx + cw-1, hy + ch, 1, 1, corner|vflags)

		local skincolor_to_chat = SG_Color2Chat or {}

		-- source
		if hit.source and not hit.targets[hit.source] then
			local color = skincolor_to_chat[hit.source.skincolor] or ''
			local font = offsets.sourcefont
			local fofs = (HEIGHT - FONTHEIGHTS[font])/2
			v.drawString(hx + offsets.left, hy + multiheight/2 + fofs, color..hit.source.name, vflags|V_ALLOWLOWERCASE, font)
		end

		-- icon
		if hit.icon and not hit.manualdraw then
			local cmap
			local icon = v.cachePatch(hit.icon)
			local scale = FixedDiv(ICONHEIGHT, max(ICONHEIGHT, icon.height))
			if hit.flash and leveltime & 2 then
				cmap = v.getColormap(TC_DEFAULT, SKINCOLOR_RED)
			else
				--cmap = v.getColormap(TC_DEFAULT, SKINCOLOR_WHITE)
				cmap = GetColorMap(v, hit.icon)
			end
			v.drawScaled((hx + offsets.icon)*FRACUNIT, (hy+multiheight/2)*FRACUNIT + ICONOFFSET, scale, icon, vflags, cmap)
		end

		-- target(s)
		-- for target, combo in pairs(hit.targets) do
		for i = 0, #hit.targetorder do
			local target = hit.targetorder[i]
			local combo = hit.targets[target]
			local color = skincolor_to_chat[target.skincolor] or ''
			local font = offsets.targetfont[target]
			local fofs = (HEIGHT - FONTHEIGHTS[font])/2
			v.drawString(hx + offsets.right, hy+i*HEIGHT + fofs, color..target.name, vflags|V_ALLOWLOWERCASE, font)
			if combo > 1 then
				local nameofs = v.stringWidth(target.name, vflags, offsets.targetfont[target]) + 1
				local color = (leveltime - hit.timestamp < TICRATE/3) and leveltime & 1 and V_ORANGEMAP or V_YELLOWMAP
				v.drawString(hx + offsets.right + nameofs, hy+i*HEIGHT, "x"..combo, vflags|color|V_ALLOWLOWERCASE, "thin")
			end
		end

		-- extra drawing function
		if hit.extrafunc then
			hit.extrafunc(v, hit, offsets, hx, hy, vflags)
		end

		hy = $ + HEIGHT + multiheight
		
		if hy >= maxhy then return end
	end
end)
